unit GaussDiffMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids;

type
  D2array = array of array of Double;
  B2array = array of array of Byte;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    MaskingBtn: TButton;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Timer1: TTimer;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    magnificationEdit: TLabeledEdit;
    ScrollBox2: TScrollBox;
    Image2: TImage;
    GroupBox1: TGroupBox;
    Size1: TLabeledEdit;
    Sigma1: TLabeledEdit;
    GroupBox2: TGroupBox;
    Sigma2: TLabeledEdit;
    Size2: TLabeledEdit;
    GroupBox3: TGroupBox;
    threshold: TLabeledEdit;
    Gain: TLabeledEdit;
    GroupBox4: TGroupBox;
    No1: TLabeledEdit;
    No2: TLabeledEdit;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MaskingBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    procedure SigumaMatSet(var Gaussian: D2array; var Total: double; MatSize :Integer; TotalGauss :Double);
    procedure Imageout(Image: TBitmap; ImageNo: integer; magnification: double);
    procedure GaussianRoutine;
    function  datasump(posY, posX: Integer): Byte;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;    // \gTCY

  Laplacian     = 0;
  Gaussians     = 1;
  Deconvolution = 2;
  Unsharp       = 3;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  GryMat        : B2array;
  Gaussian1     : D2array;
  Gaussian2     : D2array;
  DiffArray     : B2array;

const
  kr  = 0.299;                     // R PxϊW
  kg  = 0.587;                     // G PxϊW
  kb  = 0.114;                     // B PxϊW

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap; ImageNo: integer; magnification: double);
var
  Rect0           : Trect;
  MW, MH          : Integer;
begin
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  if ImageNo = 1 then begin
    Image1.Width := MW;
    Image1.Height := MH;
    Image1.Picture.Bitmap.SetSize(MW, MH);
    Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
  end;
  if ImageNo = 2 then begin
    Image2.Width := MW;
    Image2.Height := MH;
    Image2.Picture.Bitmap.SetSize(MW, MH);
    Image2.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
  end;
end;


//---------------- KEVApf[^[̌vZ -------------------------------------
// VO}̒lŃKEXžvZ܂
// gaus̒lɂAz̑傫ς܂A܂傫Ăʂ͕ς܂
//---------------------------------------------------------------------------------
procedure TForm1.SigumaMatSet(var Gaussian: D2array; var Total: double; MatSize :Integer; TotalGauss :Double);
var
  X, Y  : integer;
  KS    : Double;
  MDIV2 : integer;
  Siguma  : double;
  Dsiguma : double;

  // VO}lKEXzľvZ
  function Maskdatacalc(X, Y : Integer; Z: Double): double;
  begin
    Result := 1 / 2 / pi / Z / Z * Exp(-(X * X + Y * Y) / 2 / Z / Z);    // }XNf[^[̌vZ
  end;

begin
  setlength(Gaussian, MatSize, MatSize);
  // Џlݒ
  Siguma := 0.5;
  Dsiguma := Siguma / 2;
  MDIV2 := MatSize div 2;
  // ВlɂAV[vtB^[f[^[vZƕ\
  // Вlɂ鍇v̒lwlɂȂ悤ɒ܂
  repeat
    Total := 0;
    for Y := - MDIV2 to MDIV2 do
      for X := - MDIV2 to MDIV2 do begin
        // ВlKEXlvZ
        KS := Maskdatacalc( X, Y, Siguma);
        // }XNzɕۑ
        Gaussian[X + MDIV2, Y + MDIV2] := KS;
        // vvZ
        Total := Total + KS;
      end;
    if Total > TotalGauss then
      Siguma := Siguma + Dsiguma
    else begin
      Siguma := Siguma - Dsiguma;
      Dsiguma := Dsiguma / 2;
      Siguma := Siguma + Dsiguma;
    end;
  // vwlƍvl̍wl菬ȂI
  until abs(TotalGauss - Total) < 0.0001;
  // GaussiantB^[̒lϊ vlPɂȂ悤ɒ܂
  // ړIɂ܂KKvł͂܂
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Gaussian[X + MDIV2, Y + MDIV2] / Total;
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // Obhɕ\
    end;
end;


//--------------------------------------
// tB^[vZ^C}[x
// {^̕\؂ւVCLs̎ԑ҂
//--------------------------------------
procedure TForm1.MaskingBtnClick(Sender: TObject);
begin
  FileOpenBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  Timer1.Enabled := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  GaussianRoutine;
  FileSaveBtn.Enabled := True;
  FileOpenBtn.Enabled := True;
end;

//------------------------------------------------------
// zf[^[̎o
// z̊OX,Y oꍇoɐ܂Ԃ܂
//------------------------------------------------------
function TForm1.datasump(posY, posX: Integer): Byte;
var
  MW, MH : integer;
begin
  if posX < 0 then posX := -posX;
  MW := GWidth - 1;
  if posX > MW then begin
    posX := MW - (posX - MW);
  end;
  if posY < 0 then posY := -posY;
  MH := GHeight - 1;
  if posY > MH then begin
    posY := MH - (posY - MH);
  end;
  Result := GryMat[posY, posX];
end;

//-------------------------------------------------
// KEXtB^[ɂ{P摜vZ  Gaussian
//-------------------------------------------------
procedure TForm1.GaussianRoutine;
var
  sized1,  sized2  : Integer;
  sigmad1, sigmad2 : Double;
  threshold0       : Double;
  gain0            : Double;
  data1            : Double;
  data2            : Double;
  DataDiff         : Double;
  magnification    : Double;
  x, y             : Integer;
  xg, yg           : Integer;
  pos              : Integer;
  Mdiv2            : Integer;
  poi              : Pbytearray;
  Bdata            : Byte;
  Total            : Double;
begin
  // KEVAtB^[1
  val(Size1.Text, sized1, pos);
  if pos <> 0 then begin
    application.MessageBox('͂ɊԈႢ܂B','tB^[TCYP', 0);
    exit;
  end;
  pos := sized1 mod 2;
  if pos = 0 then begin
    application.MessageBox('TCY͊łȂ΂܂B','tB^[TCYP', 0);
    exit;
  end;
  // KEVAtB^[Q
  val(Size2.Text, sized2, pos);
  if pos <> 0 then begin
    application.MessageBox('͂ɊԈႢ܂B','tB^[TCYQ', 0);
    exit;
  end;
  pos := sized2 mod 2;
  if pos = 0 then begin
    application.MessageBox('TCY͊łȂ΂܂B','tB^[TCYQ', 0);
    exit;
  end;
  // VO}lP
  val(sigma1.Text, sigmad1, pos);
  if pos <> 0 then begin
    application.MessageBox('͂ɊԈႢ܂B','Gauss TotalP', 0);
    exit;
  end;
  if sigmad1 >= 1 then begin
    application.MessageBox('1y1ȏł͂܂B','Gauss TotalP', 0);
    exit;
  end;
  // VO}lQ
  val(sigma2.Text, sigmad2, pos);
  if pos <> 0 then begin
    application.MessageBox('͂ɊԈႢ܂B','Gauss Total Q', 0);
    exit;
  end;
  if sigmad2 >= 1 then begin
    application.MessageBox('1y1ȏł͂܂B','Gauss TotalQ', 0);
    exit;
  end;
  // 臒l
  val(threshold.Text, threshold0, pos);
  if pos <> 0 then begin
    application.MessageBox('͂ɊԈႢ܂B','臒l', 0);
    exit;
  end;
  // QC
  val(gain.Text, gain0, pos);
  if pos <> 0 then begin
    application.MessageBox('͂ɊԈႢ܂B','QC', 0);
    exit;
  end;
  // \{
  Val(magnificationEdit.Text,magnification, pos);
  if pos <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  // KEVA1tB^[f[^[̐
  SigumaMatSet(Gaussian1, Total, sized1, sigmad1);
  No1.Text := FloatTostrF(Total, ffFixed, 4, 3);
  // KEVA2tB^[f[^[̐
  SigumaMatSet(Gaussian2, Total, sized2, sigmad2);
  No2.Text := FloatTostrF(Total, ffFixed, 4, 3);
  // tB^[lvZ
  for y := 0 to GHeight - 1 do begin
    for x := 0 to GWidth - 1 do begin
      // KEXtB^[1vZ
      data1 := 0;
      MDiv2 := sized1 div 2;
      for yg := -Mdiv2 to Mdiv2 do
        for xg := -Mdiv2 to Mdiv2 do begin
          data1 := data1 + datasump(y + yg, x + xg) * Gaussian1[yg + Mdiv2, xg + Mdiv2];
        end;
      // KEXtB^[2vZ
      data2 := 0;
      MDiv2 := sized2 div 2;
      for yg := -Mdiv2 to Mdiv2 do
        for xg := -Mdiv2 to Mdiv2 do begin
          data2 := data2 + datasump(y + yg, x + xg) * Gaussian2[xg + Mdiv2, yg + Mdiv2];
        end;
      // vZ ȃ傫珬
      DataDiff := (data2 - data1) * gain0;
      // l f[^[͔]܂
      if DataDiff > threshold0 then Bdata := 0
                               else Bdata := 255;
      DiffArray[y, x] := Bdata;
    end;
  end;
  // ʉ摜\
  for y := 0 to GHeight - 1 do begin
    poi := OutputBitmap.ScanLine[y];
    for x := 0 to GWidth - 1do begin
      pos := x * 3;
      poi[pos    ] := DiffArray[y, x];
      poi[pos + 1] := DiffArray[y, x];
      poi[pos + 2] := DiffArray[y, x];
    end;
  end;
  Imageout(InputDBitmap, 1,  magnification);   // o͘g摜ɕϔ{o
  Imageout(OutputBitmap, 2,  magnification);   // o͘g摜ɕϔ{o
end;

//---------------------------------------------------
// t@C̃I[vƃOCf[^[ƃJ[̐
//---------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  X, Y        : Integer;
  PBA         : PBytearray;
  WP          : Integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        Image1.Width := GWidth;
        Image1.Height:= GHeight;
        Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  setLength(GryMat, GHeight, GWidth);
  setLength(DiffArray, GHeight, GWidth);
  for Y := 0 to Gheight - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      WP := X * 3;
      // OC摜
      GryMat[Y][X] := Round(PBA[WP] * kb + PBA[WP + 1] * kg + PBA[WP + 2] * kr); // Pxϊ
    end;
  end;
  Imageout(InputDBitmap, 1, 1);               // o͘gɕϔ{o
  MaskingBtn.Enabled := True;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

//----------------
// ݒ
//----------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Enabled := False;
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := ImageHWC;
  Image1.Top := 0;
  Image1.Left := 0;
  Image2.Width  := ImageHWC div 2;
  Image2.Height := ImageHWC div 2;
  ScrollBox2.Height := ImageHWC;
  ScrollBox2.Width  := ImageHWC;
  Image2.Top := 0;
  Image2.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  MaskingBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
end;

//----------------
// I
//----------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;


end.
